function x = cg(A,b,x0,toler,maxit);
% solves a system Ax=b
% by cg method
%%%%%%%%%%%%%%%%%%%%%%%

x=x0;
r0=b-A*x0; % initial residual
p = r0;

normR = zeros(maxit,1);

for i=1:maxit
  z = A*p;
  nu = (r0'*r0)/(p'*z);
  
  x = x + nu*p;
  
  r = r0 - nu*z;
  
  r2 = r'*r;
  
  normR(i) = sqrt(r2); % store the norm
  
  if normR(i)<toler
    break; % exit the loop
  end
  
  mu = r2/(r0'*r0);
  
  % reinitialise
  p = r + mu*p;
  r0=r;
    
end
  
  
if i==maxit
  warning('CG: maximal number of  iterations reached');
end

disp(['Finished after ',num2str(i),' iterations']);

figure(200)
plot(normR,'r*-');
title('decay of residuum for cg')