
x = 2*rand(ceil(0.25*n^2),1)-1;
y = 2*rand(ceil(0.25*n^2),1)-1;

% add border points
% unit circle:
phi = linspace(0,2*pi,n)';
% delete end point not to be twice
phi(end) = [];
bd_x = cos(phi);
bd_y = sin(phi);

n = n-1; % last point removed

% boundary value:
ud = 0.2*sin(5*phi);


% domain: out of [-1,1]^2
% leave only those which are inside of the circle
% to guarantee really INSIDE and not nearly boundary,
% set some small security radius inside
% 1-1/n;
OUT = find(x.^2+y.^2>=(1-1/n)^2);
x(OUT) = [];
y(OUT) = [];

Nodes.x = [x;bd_x];
Nodes.y = [y;bd_y];

N = length(Nodes.x); % total number of nodes

TRI = delaunay(Nodes.x,Nodes.y);

figure(1);
clf
subplot(2,1,1);
P=trimesh(TRI,Nodes.x,Nodes.y);
set(P,'color','k');
hold on
%plot(x,y,'b*')
axis equal;
title('Original triangulation');