% script visualise_iterates.m
% part of GitterReg.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% iterate x and y coordinates simultaneously
x0 = 1*ones(N-n,1); y0 = 1*ones(N-n,1);

%x0 = Nodes.x(1:N-n);
%y0 = Nodes.y(1:N-n);

%x0 = 2*rand(N-n,1)-1;
%y0 = 2*rand(N-n,1)-1;

b.x = A'*RHSx;
b.y = A'*RHSy;


%K = A;
%b.x = RHSx;
%b.y = RHSy;

x=x0; y=y0;
r0.x = b.x-K*x0; % initial residual
r0.y = b.y-K*y0;
 
p.x = r0.x;
p.y = r0.y;

maxit = 50; % how many iterations to visualise

% visualise the initial configuration
NodesVis.x = [x; bd_x];
NodesVis.y = [y; bd_y];
figure(5)
P=trimesh(TRI,NodesVis.x,NodesVis.y);
set(P,'color','m','linewidth',1);
axis equal
drawnow


waitforbuttonpress    

for i=1:maxit
  z.x = K*p.x;
  z.y = K*p.y;  
  
  nu.x = (r0.x'*r0.x)/(p.x'*z.x);
  nu.y = (r0.y'*r0.y)/(p.y'*z.y); 
  
  x = x + nu.x*p.x;
  y = y + nu.y*p.y; 
  
  if 1
    % visualise the new triangulation
    NodesVis.x = [x; bd_x];
    NodesVis.y = [y; bd_y];
    P=trimesh(TRI,NodesVis.x,NodesVis.y);
    set(P,'color','m','linewidth',1);
    axis equal
    drawnow
    %pause
  end
  
  
  r.x = r0.x - nu.x*z.x;
  r.y = r0.y - nu.y*z.y;
    
  r2.x = r.x'*r.x;
  r2.y = r.y'*r.y;  
    
  mu.x = r2.x/(r0.x'*r0.x);
  mu.y = r2.y/(r0.y'*r0.y);
    
  % reinitialise
  p.x = r.x + mu.x*p.x;
  p.y = r.y + mu.y*p.y;  
  
  r0.x=r.x;
  r0.y=r.y;  
      
end
  
